/*************************************************************
 * This file was automatically generated on 27.04.2012.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#ifndef BRICK_IMU_H
#define BRICK_IMU_H

#include "ip_connection.h"

typedef Device IMU;

#define IMU_CALLBACK_ACCELERATION 31
#define IMU_CALLBACK_MAGNETIC_FIELD 32
#define IMU_CALLBACK_ANGULAR_VELOCITY 33
#define IMU_CALLBACK_ALL_DATA 34
#define IMU_CALLBACK_ORIENTATION 35
#define IMU_CALLBACK_QUATERNION 36

void imu_create(IMU *imu, const char *uid);

int imu_get_acceleration(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_get_magnetic_field(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_get_angular_velocity(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_get_all_data(IMU *imu, int16_t *ret_acc_x, int16_t *ret_acc_y, int16_t *ret_acc_z, int16_t *ret_mag_x, int16_t *ret_mag_y, int16_t *ret_mag_z, int16_t *ret_ang_x, int16_t *ret_ang_y, int16_t *ret_ang_z, int16_t *ret_temperature);
int imu_get_orientation(IMU *imu, int16_t *ret_roll, int16_t *ret_pitch, int16_t *ret_yaw);
int imu_get_quaternion(IMU *imu, float *ret_x, float *ret_y, float *ret_z, float *ret_w);
int imu_get_imu_temperature(IMU *imu, int16_t *ret_temperature);
int imu_leds_on(IMU *imu);
int imu_leds_off(IMU *imu);
int imu_are_leds_on(IMU *imu, bool *ret_leds);
int imu_set_acceleration_range(IMU *imu, uint8_t range);
int imu_get_acceleration_range(IMU *imu, uint8_t *ret_range);
int imu_set_magnetometer_range(IMU *imu, uint8_t range);
int imu_get_magnetometer_range(IMU *imu, uint8_t *ret_range);
int imu_set_convergence_speed(IMU *imu, uint16_t speed);
int imu_get_convergence_speed(IMU *imu, uint16_t *ret_speed);
int imu_set_calibration(IMU *imu, uint8_t typ, int16_t data[10]);
int imu_get_calibration(IMU *imu, uint8_t typ, int16_t ret_data[10]);
int imu_set_acceleration_period(IMU *imu, uint32_t period);
int imu_get_acceleration_period(IMU *imu, uint32_t *ret_period);
int imu_set_magnetic_field_period(IMU *imu, uint32_t period);
int imu_get_magnetic_field_period(IMU *imu, uint32_t *ret_period);
int imu_set_angular_velocity_period(IMU *imu, uint32_t period);
int imu_get_angular_velocity_period(IMU *imu, uint32_t *ret_period);
int imu_set_all_data_period(IMU *imu, uint32_t period);
int imu_get_all_data_period(IMU *imu, uint32_t *ret_period);
int imu_set_orientation_period(IMU *imu, uint32_t period);
int imu_get_orientation_period(IMU *imu, uint32_t *ret_period);
int imu_set_quaternion_period(IMU *imu, uint32_t period);
int imu_get_quaternion_period(IMU *imu, uint32_t *ret_period);
int imu_acceleration(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_magnetic_field(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_angular_velocity(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_all_data(IMU *imu, int16_t *ret_acc_x, int16_t *ret_acc_y, int16_t *ret_acc_z, int16_t *ret_mag_x, int16_t *ret_mag_y, int16_t *ret_mag_z, int16_t *ret_ang_x, int16_t *ret_ang_y, int16_t *ret_ang_z, int16_t *ret_temperature);
int imu_orientation(IMU *imu, int16_t *ret_roll, int16_t *ret_pitch, int16_t *ret_yaw);
int imu_quaternion(IMU *imu, float *ret_x, float *ret_y, float *ret_z, float *ret_w);
int imu_get_version(IMU *imu, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]);
void imu_register_callback(IMU *imu, uint8_t cb, void *func);

#endif